'**************************************************************************
'Filename:   PQSYNTAX.BAS Vs 1.4
'Author:     Andras Hoeffken <ah@confusion.rmc.de> - 2:2480/13.34 @ fidonet
'Status:     public domain
'History:    Vs 1.0 - Sept 10, 1996 - first release to public domain
'            Vs 1.1 - Sept 12, 1996 - adapted to the German versions
'                                     of QuickBasic and QBasic
'            Vs 1.2 - Sept 15, 1996 - QB metacommands corrected
'            Vs 1.3 - Sept 16, 1996 - numerics and math operators colorized
'            Vs 1.4 - Sept 20, 1996 - better testing for menus and online help

'This TSR program runs in the background and is intended to highlight the
'keywords in the IDE of PowerBASIC Vs 3.x or QuickBasic Vs 4.5
'                       or QBasic(MS-DOS) or Basic PDS Vs 7.1.

'based on old PBSYTAX.BAS by Mike Burns, CIS:71551,1353 (released Aug 1994)
'but highly improoved, speeded up and adapted to PB 3.2 specials
'**************************************************************************

  $COMPILE EXE
  $COM 0
  $SOUND 0
  $STRING 1
  $ERROR ALL OFF
  $LIB ALL OFF
  $OPTIMIZE speed

'--------------------------------------------------------------------------

DEFINT a-z

 %debug = 0                  '1 = pulses for oscilloscope (time measurements)
 %LPT2data = &H278           'port to connect the oscilloscope

 %FALSE = 0
 %TRUE = NOT %FALSE
 %ax=1 : %bx = 2 : %dx = 4

 %StringAttr   = 1
 %ConstantAttr = 2
 %PointerAttr  = 3
 %CommentAttr  = 4
 %AsmAttr      = 5
 %KeywordAttr  = 6
 %CompilerAttr = 7
 %InternAttr   = 8
 %UserAttr     = 9

TYPE screencell
  stext AS BYTE
  attr  AS BYTE
END TYPE

DIM kcolors(1:9) AS BYTE

 'ATTENTION: SHARED (instead of PUBLIC) does not work with popup programs!
 PUBLIC kcolors(),RunAsTSR%,byteslimit
 PUBLIC swapdrive$,deffile$,scancode,shiftstatus,delaycount

  x& = SETMEM(-700000)                  'free all unused RAM (far heap)

  x& = SETMEM(8300)                     'reserve dynamic RAM (max 550 keywords)
                                        'must be set greater (300+byteslimit)
                                        'here: byteslimit = 8000 (see below)
'------------ check for Resident / Unload ----------------------------------

  usercommand$ = UCASE$(COMMAND$)       'save command line

  fpos = INSTR(usercommand$, "/F")      'definition file
  IF fpos<>0 THEN
    deffile$=RIGHT$(usercommand$, LEN(usercommand$)-fpos-2)
    deffile$=ltrim$(rtrim$(deffile$))   'user selected filename
  ELSE
    deffile$="PQSYNTAX.DEF"             'default filename
  END IF

  IF INSTR(usercommand$, "/R") > 0 THEN '"resident" command
    RunAsTSR% = %true
  ELSEIF INSTR(usercommand$,"/U") THEN  '"uninstall" command
    REG %ax, &HCCCC : REG %dx, 254      'AX and DX = ID pattern
    REG %bx, 1                          'BX = 1 --> uninstall command
    CALL INTERRUPT &H2F                 'tell the resident copy to unload
    IF REG(%ax)=&HCCCC AND REG(%dx)=254 AND REG(%bx)=1 THEN
      PRINT "PQSYNTAX Not Loaded ..."   'No tsr is loaded
    END IF
    END
  ELSE
    CLS
    PRINT "PQSYNTAX Vs 1.4 ";_
          "- Highlighting keywords in the IDE of PowerBASIC/QuickBasic/PDS"
    PRINT TAB(19);"(PB version) - (c) Andras Hoeffken <ah@confusion.rmc.de>"
    PRINT "Usage: PQSYNTAX <options>"
    PRINT "                nothing    - run once (testing default PQSYNTAX.DEF file)"
    PRINT "                /F name    - run once (testing user DEF file)"
    PRINT "                /R         - go resident using default PQSYNTAX.DEF file"
    PRINT "                /R /F name - go resident using user DEF file"
    PRINT "                /U         - unload the TSR program"
    PRINT "Evaluation of DEF file ";deffile$;" :": PRINT
    RunAsTSR% = %false
  END IF

'----------- preparations before TSR is loaded -----------------------------

IF RunAsTSR% THEN
  POPUP MULTIPLEX &HCCCC, 254           'add &H2F interrupt service to TSR
  REG %ax, &HCCCC : REG %dx, 254        'AX and DX get this pattern as an ID
  REG %bx, 0                            'BX = 0 --> install command
  CALL INTERRUPT &H2F                   'do the multiplex interrrupt
  IF REG(%bx) <> 0 THEN
    PRINT "PQSYNTAX Already Installed ....."
       BEEP : END                       'we were already installed
  ELSE
    PRINT "PQSYNTAX Vs 1.4 loaded"
  END IF
END IF

  byteslimit = 8000
  DIM PBWords?(1:8000),TempStr?(0:80)
  PUBLIC PBWords?(),TempStr?(),MaxKeyWords%

  MaxKeyWords% = LoadKeyWords           'fetch keywords from PQSYNTAX.DEF
  IF MaxKeyWords < 1 THEN
    PRINT "No Key Words Loaded, TSR not active"
    END
  END IF

IF NOT RunAsTSR% THEN GOTO notsr

  Checking% = %True                     'startup default is an active TSR
  POPUP TIMER delaycount                'every half second
  POPUP KEY CHR$(shiftstatus,scancode,&H70)  'default = CTRL-Esc
' POPUP KEY CHR$(&H04,&H01,&H70)        'e.g. CTRL-Esc
  POPUP MULTIPLEX &HCCCC, 254           'AX and DX get this pattern as an ID
  IF swapdrive$ = "R" THEN               'make tsr resident
    POPUP SLEEP
  ELSE                                  'use EMS, if not present then swapfile
    swapdrive$=swapdrive$+"PQSYNTAX.SWP"
    POPUP SLEEP USING EMS, swapdrive$   'swapfile reasonable only on RAMDISK!
  END IF

'=================== TSR interrupt service routine =========================

DO                                      'start of TSR loop

$IF %debug
  OUT %LPT2data,(INP (%LPT2data) OR 1)  'pin 1 high at entry of INT service
$ENDIF

  popmethod% = POPUP(4)                 'check the INTR reason:

  IF popmethod%=16 AND REG(%bx)=1 THEN  'a:) multiplex UNLOAD command
    PRINT "Unloading .."
    REG %ax, &HCCCC : REG %dx, 254      'AX and DX = ID pattern
    REG %bx, 3                          'alter BX to show we were here
    EXIT LOOP                           'goto label "shutdown"
  END IF
                                        'b:) other (unused) multiplex command
  IF popmethod% = 16 AND REG(%ax)=&HCCCC AND REG(%dx)=254 THEN
    REG %ax, &HCCCC : REG %dx, 254      'AX and DX = ID pattern
    REG %bx, 3                          'change BX (== answer)
    GOTO SkipProcessing                 'exit INTR service, do nothing
  END IF

  IF popmethod% = 1 THEN                'c:) KBD interrupt ALT/ESC
    Checking% = NOT Checking%
    IF Checking% = %False THEN
      POPUP TIMER OFF
      GOTO SkipProcessing
    ELSE
      POPUP TIMER ON
    END IF
  END IF
                                        'd:) timer interrupt:
notsr:
  IF PBVSCRNMODE <> 7 AND PBVSCRNMODE <> 0 THEN 'check for allowed mode
    IF LEN(DIR$("Modeerr.log")) = 0 THEN
      EFile = FREEFILE
      OPEN "O",#EFile,"PQMOERR.LOG"     'modus error
      WRITE #EFile, STR$(PBVSCRNMODE)   'log an error if bad mode found
      CLOSE #EFile
    END IF
    GOTO SkipProcessing                 'exit INTR service, do nothing
  END IF

  CALL HiLightKeyWords                  'go working on the video RAM

IF NOT RunAsTSR% THEN END               '(special exit)

SkipProcessing:

$IF %debug
  OUT %LPT2data,(INP (%LPT2data) AND NOT 1) 'pin 1 low at exit of INT service
$ENDIF

  POPUP SLEEP                           'terminate interrupt service and swap

LOOP                                    'end of TSR loop
'---------------------------------------------------------------------------

ShutDown:             'uninstall the TSR:
  POPUP TIMER 9       'popup at .5 second intervals for a max of 10 times
  REG %bx, 0
  Counter% = 0
  WHILE Counter% < 10 'give PQSYNTAX max. 5 seconds to uninstall
    POPUP SLEEP
    INCR Counter%
    IF POPUP(1) THEN
      PRINT "PQSYNTAX Removed from Memory"
      END
    ELSE
      PRINT ".";
    END IF
  WEND
  PRINT "Can NOT Remove PQSYNTAX ... - only deactivating"
  POPUP SLEEP

'===========================================================================

SUB HiLightKeyWords

  NumLines% = 25                        'default number of lines on screen
  IF PBVSCRNCARD > 3 THEN               'if ega or better:
    DIM ABSOLUTE BIOS(&H300) AS INTEGER AT 0 'because user may have changed:
    NumLines% = (BIOS(&H242) AND 255) + 1    'check actual number @ 40h:84h
    ERASE BIOS                               '(always dynamic)
  END IF

  IF PBVSCRNMODE = 7 THEN               '80 x 25 mono
    DIM Screenarea(1:4000) AS screencell AT &HB000  'array is dynamic!
    videoseg = &HB000
  ELSE                                  'color
    MaxCells% = 80 * NumLines%
    DIM Screenarea(1:MaxCells%) AS screencell AT &HB800
    videoseg = &HB800
  END IF

IF RunAsTSR THEN

  PBide = %FALSE: QBide = %FALSE        'assume this for start
  IF screenarea(6).stext = 70 THEN      '70 = "F" (File), 68 = "D" (Datei)
    PBide = %TRUE                       'PB found
  ELSEIF (screenarea(4).stext=70) OR (screenarea(4).stext=68) THEN
    QBide = %TRUE                       'QB found
  ELSE
    GOTO subex                          'otherwise finish ISR (do nothing)
  END IF

  'for quick and dirty reasons, we check the whole editor entry area, because:
  'eg. watch window may have been switched. (PB puts the watch window to the
  'bottom, QB to the top!)

  IF PBide = %TRUE THEN
    currow = 3                        'PB edit window always starts at line 3
  ELSE
    FOR temprow = 1 TO NumLines%      'QB: search first line of edit window
      IF screenarea((temprow-1)*80+1).stext = 218 THEN ' = upper left corner
        currow = temprow+1            'start of edit window
        EXIT FOR
      END IF
    NEXT
  END IF

  IF QBide = %TRUE THEN tempchar? = 32 ELSE tempchar? = 192 'space or 

  FOR temprow = currow TO NumLines%   'search for last line of edit window
    IF screenarea((temprow-1)*80+1).stext = tempchar? THEN
      lastrow = temprow-1             'end of edit window
      EXIT FOR
    END IF
  NEXT

 'see if we have an active edit screen. This is done by checking for an active
 'status line on the bottom. pb and qb vary this line on active/passive editor

 'With PB, an active status line is marked by ascii code 180 () on position 3
 'This is beginning of the Pb area showing "row:column"
 'With QB, the ID is ASC 60 (<) on pos. 2 of the last screen line

  IF PBide = %True THEN                 ' = start of 'row:column' counter
    IF screenarea(Lastrow*80+3).stext <> 180 THEN GOTO subex ' : NOT menu
    IF screenarea(162).stext = 218 THEN GOTO subex ' line 3 pos 2: online help
    IF screenarea(420).stext = 201 THEN GOTO subex ' line 6 pos 20: intro
    for i=85 to 134
      IF screenarea(i).stext = 218 THEN GOTO subex ' line 3 pos 5...54: menu
    next i
  ELSE
    i = Lastrow*80+2
    IF screenarea(i).stext = 70 THEN GOTO subex ' "F" = editor passive
    IF screenarea((currow-1)*80+4).stext = 17 THEN GOTO subex 'online help
    IF screenarea(i).stext = 77 THEN GOTO subex ' "M" = intro
  END IF

ELSE
  currow = 1: lastrow=25           'for testing purpose only
END IF

'---------------------------------------------------------------------------

  currentcell = ((currow-1) * 80) + 2 'PB /QB edit window start at column 2
  maxcell = ((lastrow-1) * 80) + 79   '  and end at column 79

  TempLen = 0
  FoundQuote% = %FALSE
  KeyWdCount = 0                   'counts the keywords on an line

  WHILE currentcell <= maxcell     'scan the whole active editor screen RAM
   IF FoundQuote% = %TRUE THEN     'process double quoted strings:
    IF (screenarea(currentcell).stext=34) OR (currentcell MOD 80)=79 THEN
      INCR currentcell             '2nd quote or end of line
      TempCell = currentcell - StrLength  'back to 1st quote
      newAttr? = kcolors(%StringAttr)
      GOSUB HiliteString
      FoundQuote% = %FALSE         'toggle off
    ELSE
      StrLength = StrLength + 1    'no highlights within quoted strings
      INCR currentcell
    END IF
   ELSE                            'process normal things
    c = screenarea(currentcell).stext
    IF c=32 then                   'space = most probable character first
      IF TempLen THEN GOSUB ChangeAttr 'look if word is a keyword
    elseif ((c>64 and c<91) or (c>96 and c<123)) then '2nd probable: alphanum
      IF c>96 AND c<123 THEN c=c-32                'make upper case
      Templen = Templen + 1: TempStr?(Templen) = c 'collect alpha TempData$
    elseif c=61 OR c=40 OR c=41 OR c=43 OR c=45 OR c=42 OR c=47_
           OR c=60 OR c=62 OR c=92 OR c=44 OR c=59 OR c=94 THEN 'delimiter
           rem =  (  )  +  -  *  /  <  >  \  ,  ;  ^
      IF TempLen THEN GOSUB ChangeAttr 'look if previous word is a keyword
      newAttr? = kcolors(%KeyWordAttr) 'colorize delimiters
      GOSUB markattr
    ELSEIF c=39 THEN               REM ' = comment delimiter
      IF TempLen THEN GOSUB ChangeAttr 'look if ' is immediately after a keywd
      TempLen = 0
      GOSUB RemarkTheLine
    ELSEIF c=58 THEN               ' : = statement delimiter
      IF TempLen THEN GOSUB ChangeAttr 'look if : is immediately after a keywd
      TempLen = 0
      newAttr? = kcolors(%CompilerAttr)
      GOSUB markattr
    ELSEIF c=34 THEN
      IF TempLen THEN GOSUB ChangeAttr 'look if " is immediately after a keywd
      FoundQuote% = %TRUE          '  toggle on
      StrLength = 2
    ELSE                           'no delimiter: continue gathering
      Templen = Templen + 1: TempStr?(Templen) = c 'collect other TempData$
    END IF
    INCR currentcell
    IF currentcell MOD 80 = 1 THEN 'begin of new line: reset some flags
      FoundQuote% = %False
      TempLen = 0
      KeyWdCount = 0
      INCR currentcell
    END IF
   END IF
  WEND
subex:
  ERASE screenarea                      'erase the dynamic screen array
  EXIT SUB

'---------------------------------------------------------------------------
ChangeAttr:
 fc = TempStr?(1)                       'first character

 IF (fc=37 or fc=38 or (fc>47 and fc<58)) THEN '%consts/&Xxxxx/numerics
   newAttr? = kcolors(%ConstantAttr)
   GOTO markattr
 ELSEIF fc = 64 THEN                    '@xxxx is a PB pointer variable
   newAttr? = kcolors(%PointerAttr)
   GOTO markattr
 END IF

 INCR KeyWdCount
 TempStr?(0)=Templen

 'This is about FIVE times faster than the PB built in ARRAY SCAN !!!
 group% = ArrayScan%(PBWords?(1),MaxKeyWords%,TempStr?(0))

 IF group% = 0 THEN                     'NOT found
   TempLen = 0
   RETURN
 ELSEIF group% = 4 THEN                 'check for a remark
   GOSUB RemarkTheLine
   TempLen = 0
   RETURN
 ELSEIF group% = 7 THEN                 'compiler attr
   if QBide% = %true then               'QB: only embedded in REMarks !
     Templen=0
     return
   end if
   newattr? = kcolors(%CompilerAttr)
 ELSEIF group% = 6 THEN                 'keyword attr
   newAttr? = kcolors(%KeyWordAttr)
 ELSEIF group% = 5 THEN                 'inline ASM
   IF KeyWdCount=1 THEN                 'first keyword on a line
     newAttr? = kcolors(%AsmAttr)
     GOSUB markattr                     'mark it
     WHILE currentcell MOD 80 > 0       'work on rest of line
       INCR currentcell
       IF screenarea(currentcell).stext=59 THEN  'if ; (= asm comment)
         GOSUB RemarkAsmLine
       END IF
     WEND
   ELSE                                 'ignore (pseudo)keyword
     TempLen = 0
   END IF
   RETURN
 ELSEIF group% = 8 THEN                 'internal PB constants/procedures
   newAttr? = kcolors(%InternAttr)
 ELSEIF group% = 9 THEN                 'user defined keywords
   newAttr? = kcolors(%UserAttr)
 END IF

'---------------------------------------------------------------------------
markattr:
 TempCell = currentcell - TempLen       'back to beginning of keyword

HiliteString:
 ! mov ax,videoseg
 ! mov es,ax
 ! mov di,TempCell
 ! dec di
 ! sal di,1
 ! inc di
 ! mov al,newattr?
 ! mov bx,currentcell
 ! dec bx
 ! sal bx,1
 ! inc bx
 ! cld

 ! cli                                  ;MUST be, otherwise the IDE
mloop:                                  '   of QBasic blocks
 ! stosb
 ! inc di
 ! cmp bx,di
 ! ja mloop
 ! sti

 TempLen = 0
 RETURN

'---------------------------------------------------------------------------

RemarkTheLine:
 if QBide = %True then                      'QB: look for embedded $STATIC etc
   startcell = currentcell                  'keep start pos in mind
   newAttr? = kcolors(%CommentAttr)         'hilite the ' or REM
   GOSUB markattr
   incr currentcell
   endofline = (currentcell \ 80) * 80 + 72 '8 before end of line ($STATIC)
   WHILE currentcell <= endofline           'scan rest of line
     c = screenarea(currentcell).stext
     if c = 32 then                         'run over spaces
     elseif c = 36 then                     'first word begins with $, OK
      Templen=0
      do                                    'scan until end of word
        IF c>96 AND c<123 THEN c=c-32                'make upper case
        Templen = Templen + 1: TempStr?(Templen) = c 'collect TempData$
        incr currentcell
        if currentcell = endofline+8 then   'not found
          currentcell = startcell
          Goto RemarkAsmLine
        else
         c = screenarea(currentcell).stext
        end if
      loop until c=32                       'space: end of word found
      TempStr?(0)=Templen
      group% = ArrayScan%(PBWords?(1),MaxKeyWords%,TempStr?(0))
      IF group% = 7 THEN                    'group = $COMPILER, OK
        newattr? = kcolors(%CompilerAttr)
        gosub markattr
      else                                  'forget it
        currentcell = startcell
      end if
      goto RemarkAsmLine
     else
       currentcell = startcell              'first word begins NOT with $
       goto RemarkAsmLine
     end if
     incr currentcell
   WEND
   return
 else
  currentcell = currentcell - TempLen       'from start of comment (REM or ')
 end if

RemarkAsmLine:
 newAttr? = kcolors(%CommentAttr)

 endofline = (currentcell \ 80) * 80 + 79   '1 before end of line
 ! mov ax,videoseg
 ! mov es,ax
 ! mov di,currentcell
 ! dec di
 ! sal di,1
 ! inc di
 ! mov al,newattr?
 ! mov bx,endofline
 ! dec bx
 ! sal bx,1
 ! inc bx
 ! cld

 ! cli                                  ;Must be, otherwise the IDE
rloop:                                  '   of QBasic blocks !!!
 ! stosb
 ! inc di
 ! cmp bx,di
 ! ja rloop
 ! sti

 currentcell = endofline + 1

 RETURN
'---------------------------------------------------------------------------

END SUB

'===========================================================================

FUNCTION LoadKeyWords           'see if we can find data file with key words

  IF LEN(DIR$(deffile$)) = 0 THEN
    PRINT "Can not find ";deffile$
    LoadKeyWords = -1
    EXIT FUNCTION
  END IF

  IF NOT RunAsTsr% THEN
    DIM DYNAMIC grouptype(1:10) AS LOCAL STRING * 10
    grouptype(1) = "strings   "
    grouptype(2) = "%constants"
    grouptype(3) = "@pointers "
    grouptype(4) = "REMarks   "
    grouptype(5) = "inline ASM"
    grouptype(6) = "keywords  "
    grouptype(7) = "$compiler "
    grouptype(8) = "pbvInter  "
    grouptype(9) = "user words"
  END IF

  MaxWords%=0
  CurWords%=0
  OldType%=0
  bcount=1
  inFile% = FREEFILE
  OPEN "I",#inFile%, deffile$
  WHILE NOT EOF(inFile%)
    LINE INPUT #inFile%, a$
    IF a$="" THEN                      'blank line
    ELSEIF LEFT$(a$,1) = ";" THEN      'comment line, do nothing
    ELSEIF LEFT$(a$,1) = "*" THEN      'type delimiter line
     CurWordType% = VAL(MID$(a$,2,1))
     IF CurWordType% = 0 THEN
      scancode = VAL(mid$(a$,13,2))
      shiftstatus = VAL(mid$(a$,30,2))
      delaycount = VAL(mid$(a$,46,2))
      swapdrive$= RIGHT$(a$,LEN(a$)-60)
      IF NOT RunAsTsr% THEN
       PRINT USING "Trigger Key: Scancode ## / Shiftstatus ## - Delaycount ##";_
             scancode,shiftstatus,delaycount;
       PRINT " - Swapdrive: '";swapdrive$;"'"
      END IF
     ELSE
      IF curwordtype% <> oldtype% THEN
        IF NOT RunAsTsr THEN
         IF curwordtype%>4 THEN
           PRINT USING "No of keywords = ###";curwords%
         ELSE
           PRINT
         END IF
        END IF
        oldtype% = curwordtype%
        curwords%=0
      END IF
      fcolor = VAL(mid$(a$,15,2))
      bcolor = VAL(mid$(a$,31,2))
      attr = 16 * bcolor + fcolor
      kcolors(CurWordType%) = CBYT(attr)
      IF NOT RunAsTsr THEN
        PRINT USING "Group # (&):  foreground = ##  background = ##   ";_
        curwordType%,grouptype(curwordType%),fcolor,bcolor;
      END IF
     END IF
    ELSE
      IF bcount + LEN(a$)+2 > byteslimit THEN
        BEEP: PRINT: PRINT "Too many keywords in PQSYNTAX.DEF - stopped"
        CLOSE #infile%: END
      END IF
      a$=UCASE$(a$)
      PBWords?(bcount)=CBYT(LEN(a$)): INCR bcount
      PBWords?(bcount)=CBYT(CurWordType%): INCR bcount
      FOR i=1 TO LEN(a$)
        PBWords?(bcount)=ASC(mid$(a$,i,1)): INCR bcount
      NEXT i
      INCR MaxWords%
      INCR curwords%
    END IF
  WEND
  IF NOT RunAsTsr THEN
    PRINT USING "No of keywords = ###";curwords%
    PRINT
    PRINT USING "Total number of bytes (max ####) found = #### / ";_
                 byteslimit,bcount-1;
    PRINT USING "total number of keywords = ###";MaxWords%
    ERASE grouptype()
  END IF
  CLOSE #inFile%
  LoadKeyWords = MaxWords%

END FUNCTION

'===========================================================================

FUNCTION Arrayscan%(PBWords?,BYVAL MaxWords%,TempStr?)

 ! push ds                         ;ax,bx,cx,dx,es are free
 ! push si
 ! push di

 ! les di,PBWords?                  ;es:di = prototype ARRAY pointer (dest)
 ! mov dx,di                        ;dx: current offset IN prototype ARRAY
 ! lds si,TempStr?                  ;ds:si = temp ARRAY pointer (source)
 ! cld

 ! mov ax,MaxWords%
 ! push bp
 ! mov bp,sp
 ! push ax                         ;SAVE MaxWord% AT bp-2

 ! xor ax,ax
 ! mov al,BYTE PTR ds:[si]
 ! mov bx,ax                       ;bx: length of temp STRING TO be searched
 ! inc si
 ! push si                         ;addr of 1st char IN temp STRING

cmplen:
 ! xor ax,ax
 ! mov al,BYTE PTR es:[di]         ;ax: length of actual prototype STRING
 ! cmp ax,bx                       ;temp AND actual, equal lengths?
 ! jne nextproto                   ;no

 ! pop si                          ;yes, look IF strings are equal:
 ! push si                         ;back TO start of temp STRING
 ! inc di
 ! inc di                          ;start of actual prototype
 ! mov cx,bx                       ;cx = REPEAT count
 ! repe cmpsb                      ;strings matching?
 ! jne nextproto                   ;no

 ! mov di,dx                       ;back TO start of actual prototype
 ! inc di                          ;position of group identifier
 ! xor ax,ax
 ! mov al,BYTE PTR es:[di]         ;ax: group of STRING found
 ! jmp short cmpfini2

nextproto:
 ! dec WORD PTR [bp-2]             ;MaxKeyWords exhausted?
 ! je  cmpfini1                    ;yes, nothing found
 ! add ax,2                        ;add extra bytes TO axtual length
 ! add dx,ax                       ;new start offset IN Prototype ARRAY
 ! mov di,dx
 ! jmp short cmplen

cmpfini1:
 ! xor ax,ax                       ;ax=0 --> nothing found
cmpfini2:
 ! add sp,4
 ! pop bp
 ! pop di
 ! pop si
 ! pop ds
 ! mov group%,ax

ArrayScan% = group%
END FUNCTION

'===========================================================================
$IF 0
SUB mysub                           ' "mysub" is an example of a USER KEYWORD

END SUB
$ENDIF
'===========================================================================
